/*
    Copyright 1998, 1999, 2000, 2001, 2003, 2004 Benhur Stein
    
    This file is part of Paj.

    Paj is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
/* PieCell.h created by benhur on Wed 24-Sep-1997 */
/*
   Cell that shows a pie-chart.
   The values of the pie are in "representedObject", that is an NSArray
   of NSDictionaries, each with a "Value", "Color", and "Name" fields.
   */
#import <AppKit/AppKit.h>
#import "StatArray.h"
#import "StatValue.h"

@interface PieCell : NSCell
{
    id dataProvider;
    StatArray *data;
    NSNumber *initialAngle;
    BOOL simple;              // true if undecorated display
    int type;
    BOOL showPercent;
}

- (void)setDataProvider:(id)provider;
- (void)setData:(StatArray *)d;

// overrides from NSCell:
- (void)drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;
- (void)setInitialAngle:(NSNumber *)angle;
- (void)setGraphType:(int)t;
- (void)setShowPercent:(BOOL)yn;
@end
