/*
    Copyright 1998, 1999, 2000, 2001, 2003, 2004 Benhur Stein
    
    This file is part of Paj.

    Paj is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Foobar is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _StatViewer_h_
#define _StatViewer_h_

#import <AppKit/AppKit.h>
#import "PieCell.h"
#import "StatArray.h"
#import "StatValue.h"
#import "../General.bproj/PajeFilter.h"

@interface StatViewer: PajeFilter
{
    id matrix;
    id window;
    PajeFilter *filter;
    NSDate *startTime;
    NSDate *endTime;
    id graphSelector;
    id graphTypeSelector;
    id percentSelector;
    id durationField;
}
- (void)awakeFromNib;

- (void)setStartTime:(NSDate *)time;
- (void)setEndTime:(NSDate *)time;

- (void)timeSelectionChanged:(NSNotification *)notification;
- (void)changeInitialAngle:(id)sender;
- (void)changeGraph:(id)sender;
- (void)changeData:(id)sender;

- (void)invalidateValues;
- (void)provideDataForCell:(PieCell *)cell;

- (void)windowDidResize:(NSNotification *)notification;
- (void)print:(id)sender;
@end

#endif
